--- madman-0.93rc2.orig/database/song.cpp	2004-03-28 19:22:31 +0300
+++ madman-0.93rc2/database/song.cpp	2005-02-01 20:10:01 +0200
@@ -1208,9 +1209,45 @@
   if (frame_id == "TCON")
     value = id3_genre_name(value);
 
-  id3_utf8_t *utf8_value = id3_ucs4_utf8duplicate(value);
-  QString result = QString::fromUtf8(reinterpret_cast<const char *>(utf8_value));
-  free(utf8_value);
+char inbuffer[ 2048 ];
+for (int i=0;i<2048;i++) inbuffer[i]= NULL;
+char *inptr = inbuffer;
+id3_ucs4_t *v=const_cast<id3_ucs4_t *>(value);
+size_t f = 0;
+while (*v) {
+  inbuffer[f] = *v;
+  f++;
+  v++;
+}
+
+cout << "WARN2:" << inptr << "\n";
+cout << "WARN3 - LENGTH:" << f << "\n";
+
+iconv_t mad_iconvt=iconv_open ("UTF-8", "CP1251");
+string res;
+
+size_t t = (size_t) 2048;
+{
+  char outbuffer[ 2048 ];
+  for (int i=0;i<2048;i++) outbuffer[i]= NULL;
+  size_t outlength = sizeof(outbuffer);
+  char *outptr = outbuffer;
+  cout << inptr << "\n";
+  if (iconv(mad_iconvt, &inptr, &f, &outptr, &outlength) == (size_t) -1)
+    throw runtime_error("Error during iconv conversion");
+    cout << "f=" << f << " t=" << outlength << "\n";
+  res += string(outbuffer, outlength);
+/*  cout << res;*/
+ }
+
+/*    id3_utf8_t *utf8_value = reinterpret_cast<const char *>(value) result.c_str();*/
+/*  id3_utf8_t *utf8_value = id3_ucs4_utf8duplicate(value);*/
+/*  QString result = QString::fromUtf8(reinterpret_cast<const char *>(utf8_value));*/
+/*  QString result = QString::fromUtf8(reinterpret_cast<const char *>(utf8_value));*/
+/*  free(utf8_value);*/
+
+QString result = QString::fromUtf8(res.c_str());
+/*QString result = QString::fromLocal8Bit(inptr);*/
 
   return result;
 }
